#include <bits/stdc++.h>
using namespace std;

const int MOD = 1e9+7;
const int Pr1 = 17, Pr2 = 19;
int r, c;
char a[1962][1962];
int h[1962][1962];

bool Check(int r1, int c1, int r2, int c2) {
    if(r2+r1-1 <= r && c2+c1-1 <= c)
        return h[r1][c1]*pow(Pr1, r2-1)*pow(Pr2, c2-1) == h[r2+r1-1][c2+c1-1];
    for(int i=1;i<=r1;i++) {
        for(int j=1;j<=c1;j++) {
            if(r2+i-1<=r && c2+j-1<=c && a[i][j] != a[r2+i-1][c2+j-1]) return false;
        }
    }
    return true;
}

bool Solve(int rt, int ct) {
    for(int i=1;i<=r;i+=rt) {
        for(int j=1;j<=c;j+=ct) {
            if(!Check(rt, ct, i, j)) return false;
        }
    }
    return true;
}

int main()
{
    cin>>r>>c;
    int i, j;
    for(i=1;i<=r;i++)
        for(j=1;j<=c;j++) {
            cin>>a[i][j];
            if(i==1 && j==1) h[i][j] = (a[i][j]-'a')*Pr1*Pr2;
            else
            h[i][j] = (h[i][j-1] + h[i-1][j] - h[i-1][j-1])%MOD;
        }
    for(i=1;i<=r;i++) {
        for(j=1;j<=c;j++) {
            if(Solve(i, j)) {
                cout<<i<<" "<<j<<" "<<0<<endl;
                return 0;
            }
        }
    }

    return 0;
}
